<?php

class ADMINWIDGETS_BOL_LinkDao extends OW_BaseDao {

    protected function __construct() {
        parent::__construct();
    }

    private static $classInstance;

    public static function getInstance() {
        if (self::$classInstance === null) {
            self::$classInstance = new self();
        }

        return self::$classInstance;
    }

    public function getDtoClassName() {
        return 'ADMINWIDGETS_BOL_Link';
    }

    public function getTableName() {
        return OW_DB_PREFIX . 'adminwidgets_links';
    }

    public function getAllLinks() {

        $query = "SELECT a.id,a.url,a.text,b.section,b.name FROM " . $this->getTableName() . " a," . ADMINWIDGETS_BOL_SectionDao::getInstance()->getTableName() . " b
                  WHERE a.section = b.section
                  ORDER BY b.section ASC";

        return $this->dbo->queryForList($query);
    }

    public function getLinksTable() {

        $query = "SELECT distinct section FROM " . $this->getTableName() . " ORDER BY section ASC";

        $sections = $this->dbo->queryForColumnList($query);

        if (empty($sections))
            return "EMPTY";

        $tableList = '<hr/><div class="datagrid"><table><tr>';

        foreach ($sections as $section) {
            $query = "SELECT a.id,a.url,a.text,b.name FROM " . $this->getTableName() . " a," . ADMINWIDGETS_BOL_SectionDao::getInstance()->getTableName() . " b
                  WHERE a.section = b.section AND a.section = :section";

            $lists = $this->dbo->queryForList($query, array('section' => $section));
            $tableList .= '<td><table>';
            $tableList .= '<tr><td><h2>' . ADMINWIDGETS_BOL_SectionDao::getInstance()->getSectionName($section) . '</h2></td></tr>';
            foreach ($lists as $list) {
                $tableList .= '<tr><td><a href="' . $list['url'] . '" target="_blank">' . $list['text'] . '</a></td></tr>';
            }
            $tableList .= '</table></td>';
        }

        $tableList .= '</tr></table></div>';

        return "<center>" . $tableList . "</center>";
    }

}