<?php

class ADMINWIDGETS_BOL_Service {

    private static $classInstance;

    public static function getInstance() {
        if (self::$classInstance === null) {
            self::$classInstance = new self();
        }

        return self::$classInstance;
    }

    private function __construct() {
        
    }

    public function getAllLinks() {
        return ADMINWIDGETS_BOL_LinkDao::getInstance()->getAllLinks();
    }

    public function getAllSections() {
        
        $example = new OW_Example();
        $example->setOrder('section ASC');

        return ADMINWIDGETS_BOL_SectionDao::getInstance()->findListByExample($example);
    }

    public function saveLink($link) {
        ADMINWIDGETS_BOL_LinkDao::getInstance()->save($link);
        $this->clearCache();
        return $link->id;
    }

    public function findLinkById($id) {
        return ADMINWIDGETS_BOL_LinkDao::getInstance()->findById($id);
    }

    public function findSectionById($id) {
        return ADMINWIDGETS_BOL_SectionDao::getInstance()->findById($id);
    }

    public function saveSection($section) {
        ADMINWIDGETS_BOL_SectionDao::getInstance()->save($section);
        $this->clearCache();

        return $section->id;
    }

    public function deleteLink($id) {
        ADMINWIDGETS_BOL_LinkDao::getInstance()->deleteById($id);
        $this->clearCache();
    }

    public function deleteSection($section) {
        $example = new OW_Example();
        $example->andFieldEqual('section', $section);

        ADMINWIDGETS_BOL_SectionDao::getInstance()->deleteByExample($example);

        $sql = "UPDATE `" . ADMINWIDGETS_BOL_LinkDao::getInstance()->getTableName() . "` SET `section` = 1 
            WHERE `section` = :section";

        OW::getDbo()->query($sql, array('section' => $section));
        $this->clearCache();
    }

    public function clearCache() {
        $example = new OW_Example();
        $example->andFieldEqual('name', 'adminwidgets');

        BOL_DbCacheDao::getInstance()->deleteByExample($example);
    }

}
