<?php

/**

 */
class ADMINWIDGETS_CMP_AdminWidget extends BASE_CLASS_Widget {

    public function __construct(BASE_CLASS_WidgetParameter $params) {
        parent::__construct();
        
		if ( OW::getUser()->isAuthenticated() && BOL_AuthorizationService::getInstance()->isModerator(OW::getUser()->getId()))
        {
			$adminwidgets = OW::getCacheService()->getInstance()->get('adminwidgets');

			if (!$adminwidgets) {
				$adminwidgets = ADMINWIDGETS_BOL_LinkDao::getInstance()->getLinksTable();
				OW::getCacheService()->getInstance()->set('adminwidgets', $adminwidgets, 60 * 60 * 24);
			}

			if ($adminwidgets != 'EMPTY') {
				$this->assign('widgetContent', $adminwidgets);
			}
        }
    }

    public static function getStandardSettingValueList() {
        return array(
            self::SETTING_TITLE => OW::getLanguage()->text('adminwidget', 'admin_widget_title'),
            self::SETTING_ICON => self::ICON_USER,
            self::SETTING_SHOW_TITLE => true,
            self::SETTING_WRAP_IN_BOX => true
        );
    }

    public static function getAccess() {
        return self::ACCESS_ALL;
    }

}